CREATE OR REPLACE
PROCEDURE Gestio_Estadistic (v_nomEntitat1 IN ESTADISTIC.nomEntitat1%TYPE, 
                    v_ID1 IN ESTADISTIC.ID1%TYPE,
                    v_nomEntitat2 IN ESTADISTIC.nomEntitat2%TYPE, 
                    v_ID2 IN ESTADISTIC.ID2%TYPE,
                    font VARCHAR2,
                    idFont NUMBER,
                    rsp OUT NOCOPY VARCHAR2) IS

    textLog VARCHAR2(255 CHAR);
    amoRow AMONESTACIO%ROWTYPE;
    sancioRow SANCIO%ROWTYPE;
    v_existeix NUMBER;
    nAmoMaxim NUMBER;
    nAmo NUMBER;
    nSancioMaxim NUMBER;
    nSancio NUMBER;
    v_anyCurs NUMBER;
    v_professor NUMBER;
    v_alumne NUMBER;
    nomProfe VARCHAR2(100 CHAR);
    v_nomAlumne VARCHAR2(100 CHAR);
    v_any NUMBER;
    
    BEGIN
        BEGIN
                -- Alta d'un nou alumne
            IF font='Alta_Alumne' THEN 
                INSERT INTO ESTADISTIC (nomEntitat1, ID1) VALUES (v_nomEntitat1,v_ID1);
                
                MERGE INTO ESTADISTIC E USING dual d
                ON (E.nomEntitat1 = 'Totals')
                WHEN MATCHED THEN UPDATE SET E.nAlumnes = E.nAlumnes + 1
                WHEN NOT MATCHED THEN INSERT (nomEntitat1, ID1,nAlumnes) VALUES ('Totals', 1,1);
            END IF;        
            
            IF font='Alta_Curs' THEN 
                SELECT anyCurs INTO v_anyCurs FROM CURS WHERE idCurs= v_ID1;
                -- alta de la combinaci curs-any
                INSERT INTO ESTADISTIC (nomEntitat1, ID1, nomEntitat2, ID2) VALUES (v_nomEntitat1,v_ID1, 'ANY', v_anyCurs);
                -- alta del curs
                INSERT INTO ESTADISTIC (nomEntitat1, ID1) VALUES (v_nomEntitat1,v_ID1);
            END IF;  
                -- alta d'un alumne a un curs
            IF font='Alta_CursAlumne' THEN
                SELECT anyCurs INTO v_anyCurs FROM CURS WHERE idCurs= v_ID2;
                
                SELECT COUNT(*) INTO v_existeix FROM ESTADISTIC WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1 AND nomEntitat2=v_nomEntitat2 AND ID2=v_ID2;
                IF v_existeix = 0 THEN
                  -- alta de la combinaci alumne-curs
                  INSERT INTO ESTADISTIC (nomEntitat1, ID1, nomEntitat2, ID2) VALUES (v_nomEntitat1,v_ID1, v_nomEntitat2, v_ID2);
                  -- afegir 1 al nombre de cursos del alumne
                  UPDATE ESTADISTIC SET nCursos= nCursos +1 WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1 AND nomEntitat2 IS NULL AND ID2 IS NULL;
                END IF;
                v_existeix := 0;
                -- alta de la combinaci alumne-any
                SELECT COUNT(*) INTO v_existeix FROM ESTADISTIC WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1 AND nomEntitat2='ANY' AND ID2=v_anyCurs;
                IF v_existeix = 0 THEN
                  INSERT INTO ESTADISTIC (nomEntitat1, ID1, nomEntitat2, ID2) VALUES (v_nomEntitat1,v_ID1, 'ANY', v_anyCurs);
                END IF;
                v_existeix := 0;
                -- alta de l'any
                SELECT COUNT(*) INTO v_existeix FROM ESTADISTIC WHERE nomEntitat1='ANY' AND ID1=v_anyCurs AND nomEntitat2 IS NULL AND ID2 IS NULL;
                IF v_existeix = 0 THEN
                    INSERT INTO ESTADISTIC (nomEntitat1, ID1) VALUES ('ANY',v_anyCurs);
                END IF;
                v_existeix := 0;
            END IF;
            
            IF font='Alta_Imparteix' or font='Modificar_Imparteix_Alta' THEN
                SELECT anyCurs INTO v_anyCurs FROM CURS WHERE idCurs= v_ID2;
                -- alta de la combinaci professor-curs si no existeix
                SELECT COUNT(*) INTO v_existeix FROM ESTADISTIC WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1 AND nomEntitat2=nomEntitat2 AND ID2=v_ID2;
                IF v_existeix = 0 THEN
                    INSERT INTO ESTADISTIC (nomEntitat1, ID1, nomEntitat2, ID2) VALUES (v_nomEntitat1,v_ID1, v_nomEntitat2, v_ID2);
                END IF;
                v_existeix := 0;
                -- alta de la combinaci professor-any si no existeix
                UPDATE ESTADISTIC SET nCursos=nCursos + 1 WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1 AND nomEntitat2='ANY' AND ID2=v_anyCurs;
                IF sql%rowcount = 0 THEN 
                    INSERT INTO ESTADISTIC (nomEntitat1, ID1, nomEntitat2, ID2, nCursos) VALUES (v_nomEntitat1,v_ID1, 'ANY', v_anyCurs, 1);
                END IF;
            END IF;

            IF font='Alta_Amonestacio' or font= 'Modificar_Amonestacio_Alta' THEN
                SELECT * INTO amoRow FROM AMONESTACIO WHERE idAmon=idFont;
                v_any:= TO_CHAR(amoRow.data,'YYYY');
                -- afegir 1 al nombre d'amonestacions de l'alumne
                UPDATE ESTADISTIC SET nAmonestacions = nAmonestacions + 1 WHERE nomEntitat1= 'Alumne' AND  ID1 = amoRow.nExpAlumne AND nomEntitat2 IS NULL AND ID2 IS NULL;
                nAmo:=0;
                -- Si es la primera amonestaci del alumne descontem 1 dels alumnes no amonestats
                SELECT nAmonestacions INTO nAmo FROM ESTADISTIC WHERE nomEntitat1='Alumne' AND ID1=amoRow.nExpAlumne AND nomEntitat2 IS NULL AND ID2 IS NULL;
                IF nAmo=1 THEN
                  UPDATE ESTADISTIC SET nAlumnes = nAlumnes - 1 WHERE nomEntitat1 = 'Totals';
                END IF;
                -- afegir 1 al nombre d'amonestacions del professor-any i calcul mitjana
                UPDATE ESTADISTIC SET nAmonestacions = nAmonestacions + 1, mitjanaAmo=(nAmonestacions + 1) / nCursos WHERE nomEntitat1='Professor'  AND  ID1 = amoRow.profResponsable 
                        AND nomEntitat2='ANY' AND ID2 =v_any;
                -- afegir 1 al nombre d'amonestacions del professor-curs
                UPDATE ESTADISTIC SET nAmonestacions = nAmonestacions + 1 WHERE nomEntitat1='Professor'  AND  ID1 = amoRow.profResponsable 
                        AND nomEntitat2='Curs' AND ID2 =amoRow.curs;
                        
                -- Actualitzar el nom del professor ms amonestador 
                SELECT MAX(nAmonestacions) INTO nAmoMaxim FROM ESTADISTIC 
                      WHERE nomEntitat1='Professor' AND nomEntitat2='Curs' AND ID2 =amoRow.curs;
                SELECT ID1 INTO v_professor from estadistic WHERE nAmonestacions=nAmoMaxim AND ROWNUM=1 AND
                       nomEntitat1='Professor' AND nomEntitat2='Curs' AND ID2 =amoRow.curs; 
                IF nAmoMaxim=0 THEN
                    SELECT nomCognoms INTO nomProfe FROM PROFESSOR WHERE nExpProfessor=amoRow.profResponsable;
                    UPDATE ESTADISTIC SET professor = amoRow.profResponsable, nomProfessor=nomProfe WHERE  nomEntitat1= 'Curs' AND ID1 = amoRow.curs AND nomEntitat2 IS NULL AND ID2 IS NULL;
                ELSE
                    SELECT nomCognoms INTO nomProfe FROM PROFESSOR WHERE nExpProfessor=v_professor;
                      UPDATE ESTADISTIC SET professor = v_professor, nomProfessor=nomProfe 
                    WHERE  nomEntitat1= 'Curs' AND ID1 = amoRow.curs AND nomEntitat2 IS NULL AND ID2 IS NULL;
                END IF;
                            
            END IF;
            
            IF font='Alta_Sancio' or font= 'Modificar_Sancio_Alta' THEN
                SELECT * INTO sancioRow FROM SANCIO WHERE idSancio=idFont;
                v_any:=TO_NUMBER(TO_CHAR (sancioRow.data, 'YYYY'));
                -- afegir 1 al nombre de ancions de Alumne-any
                UPDATE ESTADISTIC SET nSancions = nSancions + 1 WHERE nomEntitat1='Alumne'  AND  ID1 = sancioRow.nExpAlumne 
                        AND nomEntitat2='ANY' AND ID2 =v_any;
                -- afegir 1 al nombre de sancions de curs-any
                UPDATE ESTADISTIC SET nSancions = nSancions + 1 WHERE nomEntitat1='Curs'  AND  ID1 = sancioRow.curs 
                        AND nomEntitat2='ANY' AND ID2=v_any;
                -- afegir 1 al nombre de sancions de Alumne i calcul mitjana
                UPDATE ESTADISTIC SET nSancions = nSancions + 1, mitjanaSancions=(nSancions + 1) / nCursos 
                        WHERE nomEntitat1='Alumne' AND ID1=sancioRow.nExpAlumne AND nomEntitat2 IS NULL AND ID2 IS NULL;

                -- Actualitzar el nom de l'alumne ms sancionat 
                SELECT MAX(nSancions) INTO nSancioMaxim  FROM ESTADISTIC WHERE nomEntitat1='Alumne' AND nomEntitat2='ANY' AND ID2 =v_Any;
                SELECT ID1 INTO v_alumne FROM ESTADISTIC WHERE nSancions=nSancioMaxim AND ROWNUM=1 AND
			nomEntitat1='Alumne' AND nomEntitat2='ANY' AND ID2 =v_any;  
                IF nSancioMaxim=0 THEN
                    SELECT nomCognoms INTO v_nomAlumne FROM ALUMNE WHERE nExpAlumne=sancioRow.nExpAlumne ;
                    UPDATE ESTADISTIC SET alumne = sancioRow.nExpAlumne , nomAlumne=v_nomAlumne 
                            WHERE  nomEntitat1= 'ANY' AND ID1 = v_any AND nomEntitat2 IS NULL AND ID2 IS NULL;
                ELSE
                    SELECT nomCognoms INTO v_nomAlumne FROM ALUMNE WHERE nExpAlumne=v_alumne;
                    UPDATE ESTADISTIC SET alumne = v_alumne, nomAlumne=v_nomAlumne 
                        WHERE  nomEntitat1= 'ANY' AND ID1 = v_any AND nomEntitat2 IS NULL AND ID2 IS NULL;
                END IF;      
            END IF;
            
            IF font='Baixa_Alumne' THEN 
                -- Si no tenia amonestacions  descontem 1 dels almnes no amonestats
                
                SELECT nAmonestacions INTO nAmo FROM ESTADISTIC WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1 AND nomEntitat2 IS NULL AND ID2 IS NULL;
                IF nAmo=0 THEN
                  UPDATE ESTADISTIC SET nAlumnes = nAlumnes - 1 WHERE nomEntitat1 = 'Totals';
                END IF;
                DELETE FROM ESTADISTIC WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1;
            END IF; 
            
            IF font='Baixa_Curs' THEN 
                DELETE FROM ESTADISTIC WHERE (nomEntitat1=v_nomEntitat1 AND ID1=v_ID1) 
                        OR (nomEntitat2=v_nomEntitat2 AND ID2=v_ID2);
            END IF;
            
            IF font='Baixa_CursAlumne' THEN
                -- baixa de la combinaci alumne-curs
                DELETE FROM ESTADISTIC WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1 AND nomEntitat2=v_nomEntitat2 
                        AND ID2=v_ID2;

                -- treura 1 al nombre de cursos del alumne
                UPDATE ESTADISTIC SET nCursos= nCursos -1 WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1 
                        AND nomEntitat2 IS NULL AND ID2 IS NULL;
            END IF;
            
            IF font='Baixa_Imparteix' or font='Modificar_Imparteix_Baixa' THEN
                SELECT anyCurs INTO v_anyCurs FROM CURS WHERE idCurs= v_ID2;
                -- alta de la combinaci professor-curs si no existeix
                SELECT COUNT(*) INTO v_existeix FROM IMPARTEIX WHERE professor=v_ID1 AND curs=v_ID2;
                SELECT nAmonestacions INTO nAmo FROM ESTADISTIC WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1 AND nomEntitat2=nomEntitat2 AND ID2=v_ID2;
                IF font='Modificar_Imparteix_Baixa' AND v_existeix = 1 THEN
                  v_existeix := 0;
                END IF;
                IF v_existeix = 0 AND nAmo=0 THEN
                    UPDATE ESTADISTIC SET nCursos=nCursos - 1 WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1 AND nomEntitat2='ANY' AND ID2=v_anyCurs;
                    DELETE FROM ESTADISTIC WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1 AND nomEntitat2=nomEntitat2 AND ID2=v_ID2;
                END IF;
                v_existeix := 0;
            END IF;            
            
            IF font='Baixa_Professor'THEN
                DELETE FROM ESTADISTIC WHERE nomEntitat1=v_nomEntitat1 AND ID1=v_ID1;
            END IF;
            
            IF font='Baixa_Amonestacio' or font= 'Modificar_Amonestacio_Baixa' THEN

                SELECT * INTO amoRow FROM AMONESTACIO WHERE idAmon=idFont;
                
                -- treure 1 al nombre d'amonestacions de l'alumne
                UPDATE ESTADISTIC SET nAmonestacions = nAmonestacions - 1 WHERE nomEntitat1= 'Alumne' AND  ID1 = amoRow.nExpAlumne AND nomEntitat2 IS NULL AND ID2 IS NULL;
                nAmo:=0;
                -- Si era la primera amonestaci del alumne afegim 1 dels almnes no amonestats
                SELECT nAmonestacions INTO nAmo FROM ESTADISTIC WHERE nomEntitat1='Alumne' AND ID1=amoRow.nExpAlumne AND nomEntitat2 IS NULL AND ID2 IS NULL;
                IF nAmo=0 THEN
                  UPDATE ESTADISTIC SET nAlumnes = nAlumnes + 1 WHERE nomEntitat1 = 'Totals';
                END IF;
                -- treure 1 al nombre d'amonestacions del professor-any i calcul mitjana
                UPDATE ESTADISTIC SET nAmonestacions = nAmonestacions - 1, mitjanaamo=nAmonestacions - 1 / nCursos 
                        WHERE nomEntitat1='Professor'  AND  ID1 = amoRow.profResponsable 
                        AND nomEntitat2='ANY' AND ID2 =TO_CHAR(amoRow.data,'YYYY');
                -- treure 1 al nombre d'amonestacions del professor-curs
                UPDATE ESTADISTIC SET nAmonestacions = nAmonestacions - 1 WHERE nomEntitat1='Professor'  AND  ID1 = amoRow.profResponsable 
                        AND nomEntitat2='Curs' AND ID2 =amoRow.curs;
                        
                -- Actualitzar el nom del professor ms amonestador      
                SELECT MAX(nAmonestacions) INTO nAmoMaxim FROM ESTADISTIC 
                      WHERE nomEntitat1='Professor' AND nomEntitat2='Curs' AND ID2 =amoRow.curs;
                SELECT ID1 INTO v_professor from estadistic WHERE nAmonestacions=nAmoMaxim AND ROWNUM=1 AND
                       nomEntitat1='Professor' AND nomEntitat2='Curs' AND ID2 =amoRow.curs; 
                IF nAmoMaxim=0 THEN
                  UPDATE ESTADISTIC SET professor = NULL, nomProfessor=NULL 
                  WHERE  nomEntitat1= 'Curs' AND ID1 = amoRow.curs AND nomEntitat2 IS NULL AND ID2 IS NULL;
                ELSE
                  SELECT nomCognoms INTO nomProfe FROM PROFESSOR WHERE nExpProfessor=v_professor;
                      UPDATE ESTADISTIC SET professor = v_professor, nomProfessor=nomProfe 
                  WHERE  nomEntitat1= 'Curs' AND ID1 = amoRow.curs AND nomEntitat2 IS NULL AND ID2 IS NULL;
                END IF;       
            END IF;
            
            IF font='Baixa_Sancio' or font= 'Modificar_Sancio_Baixa' THEN
                SELECT * INTO sancioRow FROM SANCIO WHERE idSancio=idFont;
                v_any:=TO_NUMBER(TO_CHAR (sancioRow.data, 'YYYY'));
                -- treure 1 al nombre de ancions de Alumne-any
                UPDATE ESTADISTIC SET nSancions = nSancions - 1 WHERE nomEntitat1='Alumne'  AND  ID1 = sancioRow.nExpAlumne 
                        AND nomEntitat2='ANY' AND ID2 =v_any;
                -- treure 1 al nombre de sancions de curs-any
                UPDATE ESTADISTIC SET nSancions = nSancions - 1 WHERE nomEntitat1='Curs'  AND  ID1 = sancioRow.curs 
                        AND nomEntitat2='ANY' AND ID2=v_any;
                -- treure 1 al nombre de sancions de Alumne-curs i calcul mitjana
                UPDATE ESTADISTIC SET nSancions = nSancions - 1, mitjanaSancions=nSancions - 1 / nCursos 
                        WHERE nomEntitat1='Alumne'  AND  ID1 = sancioRow.nExpAlumne AND nomEntitat2 IS NULL AND ID2 IS NULL;
                -- Actualitzar el nom de l'alumne ms sancionat 
                SELECT MAX(nSancions) INTO nSancioMaxim  FROM ESTADISTIC WHERE nomEntitat1='Alumne' AND nomEntitat2='ANY' AND ID2 =v_Any;
                SELECT ID1 INTO v_alumne FROM ESTADISTIC WHERE nSancions=nSancioMaxim AND ROWNUM=1 AND
			nomEntitat1='Alumne' AND nomEntitat2='ANY' AND ID2 =v_any; 
                IF nSancioMaxim=0 THEN
                  UPDATE ESTADISTIC SET alumne = NULL, nomAlumne=NULL 
                  WHERE  nomEntitat1= 'ANY' AND ID1 = v_any AND nomEntitat2 IS NULL AND ID2 IS NULL;
                ELSE
                  SELECT nomCognoms INTO v_nomAlumne FROM ALUMNE WHERE nExpAlumne=v_alumne;
                  UPDATE ESTADISTIC SET alumne = v_alumne, nomAlumne=v_nomAlumne 
                  WHERE  nomEntitat1= 'ANY' AND ID1 = v_any AND nomEntitat2 IS NULL AND ID2 IS NULL;
                END IF;
            END IF;
            
            IF font='Modificar_Curs' THEN
                SELECT anyCurs INTO v_anyCurs FROM CURS WHERE idCurs= v_ID1;
                SELECT COUNT(*) INTO v_existeix FROM ESTADISTIC WHERE nomEntitat1='ANY' AND ID1=v_anyCurs AND nomEntitat2 IS NULL AND ID2 IS NULL;
                IF v_existeix = 0 THEN
                    INSERT INTO ESTADISTIC (nomEntitat1, ID1) VALUES ('ANY',v_anyCurs);
                END IF;
                v_existeix := 0; 
            END IF;
                     
            rsp:='OK';  
            COMMIT;
            
        EXCEPTION
            WHEN OTHERS THEN 
            rsp:='Error:'||SQLERRM;
            ROLLBACK;
        END;
           -- anotar a la taula de log
        textLog:=('nomEntitat1='|| v_nomEntitat1 || ', ID1=' || v_ID1 || ', nomEntitat2='|| v_nomEntitat2 || 
                    ', ID2=' || v_ID2 || ', font=' || font || ', idFont=' || idFont); 
        insert_log('Gestio_Estadistic', textLog, '', rsp);

    END;                          
