
-- Llistat de totes les amonestacions imposades
CREATE OR REPLACE PROCEDURE Ll_Amonestacions(v_cursor OUT SYS_REFCURSOR, RSP OUT VARCHAR2)IS

    textLog VARCHAR2(255 CHAR);
    BEGIN

        BEGIN
            -- Obrir cursor 
            OPEN v_cursor FOR 
                SELECT A.nExpAlumne, A.data, A.hora, T.tAmonestacio, A.profResponsable, A.gravetat, A.comPares, A.Sancio
                 FROM AMONESTACIO A INNER JOIN T_AMONESTACIO T ON T.idTipusAmo=A.tAmoN
                 ORDER BY A.data, A.hora;
                  
            RSP:='OK';
            
        EXCEPTION
            WHEN OTHERS THEN 
                rsp:='Error:'||SQLERRM;
        END;
            -- anotar a la taula de log
        textLog:=('cursor= nExpAlumne, data, hora, tAmonestacio, profResponsable, comPares, Sancio');
        insert_log('Ll_Amonestacions', '', textLog, rsp);
    END;

	
-- Llistat de tots els alumnes d'un curs 
CREATE OR REPLACE PROCEDURE Ll_Alumnes_Curs(v_curs IN CURS.idCurs%TYPE,
		v_cursor OUT SYS_REFCURSOR,
		 RSP OUT VARCHAR2)IS

textLog VARCHAR2(255 CHAR);
BEGIN

	BEGIN
		--Obrir Cursor
		OPEN v_cursor FOR 
			SELECT A.nExpAlumne, A.NIF, A.nomCognoms, A.adreca, A.telefon, A.email 
				FROM ALUMNE A INNER JOIN CURS_ALUMNE CA ON A.nExpAlumne=CA.nExpAlumne 
				WHERE CA.idCurs=v_curs ORDER BY A.nExpAlumne;
			 
		RSP:='OK';
		
	EXCEPTION
	
		WHEN OTHERS THEN 
			rsp:='Error:'||SQLERRM;
			ROLLBACK;
	
	END;
		-- anotar a la taula de log
	textLog:=('cursor= nExpAlumne, NIF, nomCognoms, adreca, telefon, email'); 
	insert_log('Ll_Alumnes_Curs', 'Curs=' || v_curs, textLog, rsp);
END;

-- Llistat de totos els tipus d'amonestacions i sancions disponibles per aplicar al centre
CREATE OR REPLACE PROCEDURE Ll_T_AmonestacionsSancions (v_cursor OUT SYS_REFCURSOR,
		 RSP OUT VARCHAR2)IS

textLog VARCHAR2(255 CHAR);
BEGIN

	BEGIN
		--Obrir Cursor
		OPEN v_cursor FOR 
			SELECT 'Amonestaci' as Classe, TA.idTipusAmo as ID, TA.tAmonestacio as Tipus, TA.descripcio as Descripcio
					FROM T_AMONESTACIO TA
			UNION
			SELECT 'Sanci' as Tipus,TS.idTipusSancio, TS.tSancio, TS.quanActiva
					FROM T_SANCIO TS;
			 
		RSP:='OK';
		
	EXCEPTION
		WHEN OTHERS THEN 
			rsp:='Error:'||SQLERRM;
			ROLLBACK;
	END;
		-- anotar a la taula de log
	textLog:=('cursor= Classe, ID, Tipus, Descripcio'); 
	insert_log('Ll_T_AmonestacionsSancions', '', textLog, rsp);
 END;
 
--  Llistat de totes les amonestacions i sancions d'un alumne
CREATE OR REPLACE PROCEDURE Ll_AmonSancions_Alumne (v_nExpAlumne IN ALUMNE.nExpAlumne%TYPE,
			v_cursor OUT SYS_REFCURSOR,
			RSP OUT VARCHAR2) IS

textLog VARCHAR2(255 CHAR);
BEGIN

	BEGIN
		--Obrir Cursor
		OPEN v_cursor FOR 
			SELECT 'Amonestaci' as Classe, A.data, A.hora, T.tAmonestacio as Tipus
					FROM AMONESTACIO A INNER JOIN T_AMONESTACIO T ON T.idTipusAmo=A.tAmon 
					WHERE A.nExpAlumne = v_nExpAlumne
			UNION
			SELECT 'Sanci' as Tipus, A.data, A.hora,T.tSancio
					FROM SANCIO A INNER JOIN T_SANCIO T ON T.idTipusSancio=A.tipus 
					WHERE A.nExpAlumne = v_nExpAlumne;
			 
		RSP:='OK';
		
	EXCEPTION
	
		WHEN OTHERS THEN 
			rsp:='Error:'||SQLERRM;
			ROLLBACK;
	
	END;
		-- anotar a la taula de log
	textLog:=('cursor= Classe, nExpAlumne, data, hora, Tipus'); 
	insert_log('Ll_AmonSancions_Alumne', 'nExpAlumne= ' || v_nExpAlumne, textLog, rsp);

END;